function[laispw2,y,maxtabv_ext,mintabv_ext,maxtab_ext,mintab_ext]=plot_lai_spline_detect_anomalies(datejul_value, datestr_value, zi_code,imageprefix,lai_mean,lai_std)
%
%PLOT_LAI_SPLINE_DETECT_ANOMALIES plot ++
%
%+
%
% ==================================
% plot_lai_spline_detect_anomalies.m
% ==================================
%
% .. function:: plot_lai_gis(datejul_value, datestr_value, lai_value, classes_value, msdnom_value, classes_select, msdnom_select, zi_code, imageprefix)
%
% DESCRIPTION
% ===========
%
%    :param classes_select: classes we want to select ex: '"Savane herbacee et arbustive"'
%    :type classes_select: string
%    :raise classes_select: required
%
%    :param msdnom_select: msdnom we want to select ex: "FERRUGINEUX TROPICAUX"
%    :type msdnom_select: string
%    :raise msdnom_select: required
%
%    :param zi_code: zi_code zone where take data (!! no check is made here)
%    :type zi_code: string
%    :raise zi_code: required
%
%    :param imageprefix: string to be used at the beginning of the image file
%    :type imageprefix: string
%
%    :returns: 0 if ok or -1 if error
%    :rtype: integer
%
% If ``classes_select`` is empty (:samp:`''`), no criterium on classes_value
% value is applied to select data.
%
% If ``msdnom_select`` is empty (:samp:`''`), no criterium on msdnom_value
% value is applied to select data.
%
% If ``imageprefix`` is empty (:samp:`''`), no image is saved, else
% :file:`${PROJECT_OD}/{mageprefix}_{zi_code}_s{type_de_sol}_v{type_de_vegetation}.jpeg` is saved.
%
% EXAMPLES
% ========
%
% see demo
%
% SEE ALSO
% ========
%
% :ref:`data_lai`
% :ref:`zones`
%
% :func:`simul_lai_gis` ++
% :func:`read_lai_gis`
% :func:`select_lai_gis`
% :func:`select_lai_gis_geobox`
%
% called by :func:`graphe_zicode`
%
% use :func:`peakdet`
%
% TODO
% ====
%
% changement de classification de végétation (FAO) donc changer les classes_select pour
% avoir (ou pas) des LAI
%
% changer le nom des fichiers suite à chgt de terminologie dans read_lai_gis.m
%
% est-ce que index_juin est utilisé si select_lai_gis a été
% utilisé?
%
% error bar instead of star on minima and maxima
%
% sur matlab on ne voit pas la courbe bleu : cachée sous le jbfill ?
%
% why "x10^5" on matlab figure nearby X axis
%
% même style de ligne pour toutes les courbes
%
% ajouter un mode de graphique en paramètre pour superposer ou pas
%
% vérifier l'argument seuil uint16
%
% zi_code ici en argument est utilisé pour fabriquer le titre : il n'y a aucune
% vérification que les lat_value et lon_value correspondent
% effectivement à cette zi !
%
% vérifier que zi_code n'est pas vide si imageprefix n'est pas vide
%
% vérifier que le calcul de aa_moy et de aa_ecartype doit bien être à
% l'intérieur de la boucle sur les pas de temps. cela peut remettre
% en cause l'initialisation de ces grandeurs
%
% add simulation demo
%
% coding rules
%
% check arg
%
% EVOLUTIONS
% ==========
%
% $Id: plot_lai_gis.m 423 2011-11-15 12:06:40Z pinsard $
%
% $URL: svn+ssh://pinsard@forge.ipsl.jussieu.fr/ipsl/forge/projets/varamma/svn/trunk/src/plot_lai_gis.m $
%
% - soclod 20120911
%
%   * add mintab et maxtab without variance
%   * add datevec2doy for changing format to julien days
%
% - soclod/fplod 20111125
%
%   * add an example of select_lai_gis_geobox usage
%   * correction of demo because nb of outputs modifications
%
% - soclod 201111++
%
%   * aa_moy and aa_ecarttype are not computed anymore : remove from outputs
%
% - fplod 20111115T113823Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * add an example of select_lai_gis usage
%   * first and last month on x axis adjust to first and last
%     month of data
%
% - fplod 20111115T084643Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * add peak detection
%
% - soclod/lelod 201111??
%
%   * remove computation of aa_moy aa_ecarttype
%   * introduce index_juin for ??
%
% - fplod 20111104T103521Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * xtick on each 1st day of month
%   * remove yyyy forcing to 2008; yyyy is defined according
%     to the first value of datejul_value input array
%   * restore figure incrementation
%
% - fplod 20111104T100039Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * avoid crash when matlab is running (no gcvspl available)
%     even if exists, need to change syntax of call because matlab does not
%     support argument syntax of this form result=myfunc(arg1=1).
%     prefer arg=1;result=myfunc(arg1).
%
% - fplod 20111103T140749Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * fix legend problem
%   * restore plot of écart-type
%
% - lelod 20111018
%
%   * add usage of gcvspl
%     for spline smoothing and second derivative
%
% - fplod 20110929T163627Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * resolution du pb de légende : si on a plusieurs courbes il n'y a qq'une
%     seule légende et c'est la légende de la dernière courbe qui apparait
%     thanks to http://www.mathworks.com/matlabcentral/newsreader/view_thread/168868
%     (setting userdata on each plot and get gca children info to define final
%     legend
%
% - fplod 20110929T144859Z cratos (Linux)
%
%   * suppression de classes dans le titre
%   * ajout de classes dans la légende
%   * ajout de nb de points dans la légende
%
% - soclod ??
%
%   * superposition de courbes
%   * changement de la légende et du titre
%
% - soclod/fplod 20110927
%
%   * add seuil parameter
%
% - fplod 20110923T074248Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * adjust message
%   * fix indentation
%
% - fplod 20110915T075353Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * suppress gridcode_value
%   * authorized no selection criteria on classes_value and msdom_value.
%     title of the figure is modified to see only non-empty criteria.
%     add 2 demos
%
% - fplod 20110909T141946Z cratos (Linux)
%
%   * save figure
%   * correction demo (more outputs)
%   * add parameter imageprefix
%
% - fplod 20110829T074158Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * aller à la ligne dans un titre
%   * tick label = dd/mm/yyyy (4 digigts for year)
%
% - fplod 20110823T132026Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * replace gricode and msd by classes_select and msdnom_select
%     to have more human readable software
%   * add check argument zi_code type
%
% - fplod 20110823T124532Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * allow successive calls without destroying existing figures
%
% - soclod 20110822
%
%   * add zi_code as paramater
%   * verification argument
%   * change demos
%
% - fplod/soclod 20110819
%
%   * remove hard coded title and xlabel values
%   * add init of aa_moy and aa_ecartype to avoid warning if
%     combinaison not found
%
% - soclod 20110818
%
%   * correction demo (more outputs)
%   * (fplod) pas de sortie en erreur si combinaison non trouvée : un message
%     seulement
%
% - soclod 20110816
%
%   * add msd parameter
%   * add test of data found
%   * add demo with no data found
%
% - soclod 20110812
%
%   * ajout de sorties aa_moy et aa_ecartype les moyennes et écarts-types filtrés
%
% - soclod/fplod 20110812T145149Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * add and run demo with LAI2008F_veg2010_sol_barkedji.csv
%
% - fplod 20110812T140844Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * minimal header
%   * rehabilitation of demo from real file with no zi
%   * replace la2008i_Clip_Intersect_Inter.csv by LAI2008F_veg2010_sol.csv
%   * replace num_classe by gridcode
%
%-
%
global application
global PROJECT_OD
%
usage='[laispw2, y]=plot_lai_spline(datejul_value, datestr_value, lai_mean)';

%
if nargin~=nargin(mfilename)
   disp(['Incorrect number of input arguments ' num2str(nargin)]);
   error(usage)
end
%
if nargout ~= nargout(mfilename)
   disp(['Incorrect number of output arguments ' num2str(nargout)]);
   error(usage);
end
%
%arg_info=whos('classes_select');
%if ~strcmp(arg_info.class,'char')
 %  disp(['Incorrect type of arg classes_select ' arg_info.class]);
  % whos classes_select
  % error(usage);
%end
%clear arg_info
%
%arg_info=whos('msdnom_select');
%if ~strcmp(arg_info.class,'char')
 %  disp(['Incorrect type of arg msdnom_select ' arg_info.class]);
 %  whos msd
 %  error(usage);
%end
%clear arg_info
%
arg_info=whos('zi_code');
if ~strcmp(arg_info.class,'char')
    disp(['Incorrect type of arg zi_code ' arg_info.class]);
    whos zi_code
    error(usage);
end
clear arg_info
%
arg_info=whos('imageprefix');
if ~strcmp(arg_info.class,'char')
    disp(['Incorrect type of arg imageprefix ' arg_info.class]);
    whos imageprefix
    error(usage);
end
clear arg_info
%
% trace des lai moyens et écart-type pour une classe de végétation
% choisie avec classes_select (tri dans le tableau classes_value) et avec
% msdnom_select (tri dans le tableau msdnom_value)
%
%nb_doy= size(lai_value,1);
%lai_mean=zeros(1,nb_doy);
%lai_std=zeros(1,nb_doy);
%aa_moy=zeros(1,nb_doy);
%aa_ecartype=zeros(1,nb_doy);
%
% select asked data
% choix de la classe de vegetation et du type de sol
% if msdnom_select and classes_select are not empty, use both criteria
%if (~isempty(msdnom_select) && ~isempty(classes_select))
%    ind_value=find(strcmp(classes_value,classes_select) & strcmp(msdnom_value,msdnom_select));
%elseif (~isempty(msdnom_select) && isempty(classes_select))
 %   ind_value=find(strcmp(msdnom_value,msdnom_select));
%elseif (isempty(msdnom_select) && ~isempty(classes_select))
%    ind_value=find(strcmp(classes_value,classes_select));
%elseif (isempty(msdnom_select) && isempty(classes_select))
%    ind_value=1:size(lai_value,2);
%else
%    disp(['eee : unknown combination of msdnom_select and classes_select to be found']);
%    error(usage);
%end
%
%if isempty(ind_value);
%    disp(['www : combinaison classes_select = ' classes_select ' and  msdnom_select = ' msdnom_select ' not found' ])
%else
 %   aa=numel(ind_value);
 %   disp(['iii : nb point dans la combinaison ' classes_select ' ' msdnom_select ' vaut ' num2str(aa)])
  %  if (aa < seuil)
  %      disp(['iii : pas assez de points (' num2str(aa) ' < ' num2str(seuil) ' )'])
  %  else
       % calcul moyenne et écart-type
       % filtre des valeurs moyennes et des écarts-types
       % index_juin=20;
   %    for index_doy=1:nb_doy

    %       lai_mean(index_doy)=mean(lai_value(index_doy,ind_value));
     %      lai_std(index_doy)=std(lai_value(index_doy,ind_value));
          % p=5;
          % aa_moy=filter(ones(1,p)/p,1,lai_mean);
          % aa_ecartype=filter(ones(1,p)/p,1,lai_std);
      % end
       % initialize a new figure
  % ifigure=gcf()+1;
  %figure(ifigure);
       %ifigure=1;
       %figure(ifigure);
       % build legend
     %  malegende_p1='';
      % if ~isempty(classes_select)
           %montitre=[montitre sprintf('classe : %s\n', classes_select)];
       %    malegende_p1=[malegende_p1 sprintf('%s', classes_select)];
       %else
        %   malegende_p1=[malegende_p1 'toutes vegetations'];
       %end
       %if ~isempty(msdnom_select)
          %montitre= [montitre sprintf('type de sol : %s\n ', msdnom_select)];
        %  malegende_p1= [malegende_p1 sprintf(' - %s', msdnom_select)];
       %else
        %  malegende_p1= [malegende_p1 ' - tous sols'];
       %end
       %malegende_p1=[malegende_p1 sprintf(' (%d points)', aa)];
       %malegende_p2='spline';
       %malegende_p3='dérivée 2de de spline';
       %malegende_p4='+/- écart-type';
       %
        % lissage de la moyenne par spline
       x=transpose(datejul_value);
       y=transpose(lai_mean);
       lai_var=lai_std.^2;
       varmean=mean(lai_var);
      xk=transpose((varmean)./lai_var);

      switch application
           case {'matlab'}
              disp(['www : no gcvspl available using ', application]);
              laispw=[];
              laispw2=[];
           case {'octave'}
              gcvspl_arg6=[];
              xf=x;
              m=2;
              md=2;
              val=1;
              ider=[0];
               % spline pondere par l'inverse de la variance
              % normalisee
              [laispwv,wk]=gcvspl(x,y,xf,xk,gcvspl_arg6,m,md,val,ider);
             % spline non pondere par l'inverse de la variance
               [laispw,wk]=gcvspl(x,y,xf,[],[],m,md,val,ider);
              ider=[2];
              % avec la variance
              [laispw2v,wk]=gcvspl(x,y,xf,xk,gcvspl_arg6,m,md,val,ider);
              % sans la variance
              [laispw2,wk]=gcvspl(x,y,xf,[],[],m,md,val,ider);
          otherwise
              error('eee : unknown application running');
       end
       hold on
       % trace des lai autour de la moyenne [0.9 0.9 0.9] la courbe
       % grise devient plus claire si on diminue ça devient plus fonce
       [p1,msg]=jbfill(datejul_value,lai_mean+lai_std,lai_mean-lai_std,[0.9 0.9 0.9],[1 1 1],.2);
       %set(p1, 'userdata',malegende_p4);
       hold on
       size(lai_mean)
       p2=plot(datejul_value,lai_mean,'b-.','linewidth',3);
       %set(p2, 'userdata',malegende_p1);
       %if ~isempty(laispw)
        %   tracé de l'ajustement par le spline
           p3=plot(datejul_value,transpose(laispw),'r-','markersize',3,'linewidth',3);
         %transpose(laispw)
          % set(p3, 'userdata',malegende_p2);
           %hold off
           % tracé de la dérivée seconde du spline
           p4=plot(datejul_value,transpose(laispw2*1000),'k:.','linewidth',2);
           %set(p4, 'userdata',malegende_p3);
           x=datejul_value;
           y=transpose(laispw2v*1000);
           yv=transpose(laispw2*1000);
           % maxtabv et mintabv indique max de courbure  et min de courbure avec la variance
           [maxtabv, mintabv] = peakdet(yv, 0.01, x);
           % maxtab et mintab indique max  de courbure  et min de
           % courbure sans la variance
           [maxtab,mintab]=peakdet(y,0.01,x)
          % conversion des maximas et minimas en jour julien
           maxtabv_ext=datevec2doy(datevec(maxtabv))
           mintabv_ext=datevec2doy(datevec(mintabv))
           maxtab_ext=datevec2doy(datevec(maxtab))
           mintab_ext=datevec2doy(datevec(mintab))

          % mintab_ext1=datevec2doy(datevec(mintab))
           disp([ '1er max a : ' datestr(maxtab(6,1)) '-'  num2str(maxtab(6
,1))]);
            disp([ '1er min a : ' datestr(mintab(6,1)) '-'  num2str(mintab(6,1))]);
           disp([ 'value 1er max : ' num2str(maxtab(1,2))]);
           % tracé des maximas et des minimas calculés avec la variance
           hold on
           p5=plot(mintabv(:,1), mintabv(:,2), 'g*','markersize',5);
           set(p5, 'userdata','min');
          % hold off
          % hold on
           p6=plot(maxtabv(:,1), maxtabv(:,2), 'r+','markersize',5);
           set(p6, 'userdata','max');
% end
       % tracé des maximas et minimas calculés sans la variance
       p7=plot(mintab(:,1), mintab(:,2), 'ko','markersize',5);
       p8=plot(maxtab(:,1), maxtab(:,2), 'bx','markersize',5);
 %      hold off
%
       hx=xlabel(['jours (jj/mm/yy) entre '  datestr_value(14,:) ' et ' datestr_value(end,:)],'fontsize',14);
       hy=ylabel('LAI','fontsize',14);

       yyyy=str2num(datestr(datejul_value(1),'yyyy'));
       set(gca,'xtick',datenum(yyyy,5:13,1))
       clear yyyy
       clear mm_min
       clear mm_max
       datetick('x','dd/mm/yy','keepticks');       %montitre=sprintf('zi_code : %s\n', zi_code);

       ylim([-3 3]);
      % xlim([maxtab(5,1) mintab(5,1)])
       grid('on');
       %..collect labels from each curve and put up legend
       hc=get(gca,'children');
       s={};
       for h=hc'
           s={s{:},get(h,'userdata')};
       end
        h_legend=legend('{\fontsize{11}+/-écart-type}','{\fontsize{11}"Savane arboree arbustive"-"FERRUGINEUX TROPICAUX"}')
       % legend(hc,s)
    %  h_legend=legend('{\fontsize{11}+/-écart-type}','{\fontsize{11}"Savane arboree arbustive"-"FERRUGINEUX TROPICAUX"}', ...
%                          '{\fontsize{11}spline}','{\fontsize{11}derivee 2nde de spline}','{\fontsize{11}min}','{\fontsize{11}max%}')
      %set(h_legend, 'fontsize',14)

      % save figure
       if ~isempty(imageprefix)
           printer='jpeg';
           print_printer=['-d', printer];
           fullfilename=[PROJECT_OD imageprefix zi_code];
           if ~isempty(msdnom_select)
               s_infilename=regexprep(lower(msdnom_select),' ','_');
               s_infilename=regexprep(s_infilename,'"','');
               fullfilename=[fullfilename '_s' s_infilename];
           end
           if ~isempty(classes_select)
               v_infilename=regexprep(lower(classes_select),' ','_');
               v_infilename=regexprep(v_infilename,'"','');
               fullfilename=[fullfilename '_v' v_infilename];
           end
           fullfilename=[fullfilename '.' printer];
           clear printer;
           print(print_printer,fullfilename);
           clear print_printer;
           clear fullfilename;
      end
%end

result=0;

end
